import gtk
import gtk.glade
import subprocess
import os


import gettext
import locale


locale.textdomain("nat-manager")
gettext.textdomain("nat-manager")
_=gettext.gettext

class NatManager:
	
	def __init__(self):

		self.ext_var="NET_EXT_IFACE"
		self.int_var="NET_INT_IFACE"
		self.nat_gui_status=False
		self.routing_gui_status=False
		
		if (os.path.exists("../rsrc/nat-manager.glade")):
			self.glade= gtk.glade.XML("../rsrc/nat-manager.glade")
		else:
			self.glade= gtk.glade.XML("/usr/share/zero-center-server-basics/rsrc/nat-manager.glade")
			
		self.window=self.glade.get_widget("window1")
		
		self.nat_list=[]
		
		self.nat_disabled_list=[]
		
		self.checkPersistent=self.glade.get_widget("checkPersistent")
		self.nat_disabled_list.append(self.checkPersistent)
		self.msgLabel=self.glade.get_widget("msgLabel")
		self.applyButton=self.glade.get_widget("applyButton")
		self.internalCombobox=self.glade.get_widget("internalCombobox")
		self.nat_disabled_list.append(self.internalCombobox)
		self.externalCombobox=self.glade.get_widget("externalCombobox")
		self.nat_disabled_list.append(self.externalCombobox)
		self.label1=self.glade.get_widget("label1")
		self.nat_list.append(self.label1)
		self.label2=self.glade.get_widget("label2")
		self.nat_disabled_list.append(self.label2)
		self.label3=self.glade.get_widget("label3")
		self.nat_disabled_list.append(self.label3)
		self.image2=self.glade.get_widget("image2")
		self.nat_list.append(self.image2)
		self.enableNatDisabled=self.glade.get_widget("enableNatDisabled")
		self.nat_list.append(self.enableNatDisabled)
		self.enableNatEnabled=self.glade.get_widget("enableNatEnabled")
		self.nat_list.append(self.enableNatEnabled)
		self.closeButton=self.glade.get_widget("closeButton")

		self.routingEnabledRadio=self.glade.get_widget("routingEnabledRadio")
		self.routingDisabledRadio=self.glade.get_widget("routingDisabledRadio")
		
		
		self.window.connect("destroy",gtk.main_quit)
		self.applyButton.connect("clicked",self.applyButtonPress)
		self.closeButton.connect("clicked",gtk.main_quit)
		self.routingEnabledRadio.connect("toggled",self.routingNATRadioToggled)
		self.enableNatEnabled.connect("toggled",self.enableNatEnabledToggled)

		self.window.show_all()
		self.window.set_position(gtk.WIN_POS_CENTER_ALWAYS)


		self.checkForEth()
		#self.checkNAT()
		self.checkStatus()

		gtk.main()
		
	#def __init__
	
	

	
	def routingNATRadioToggled(self,togglebutton):
		
		self.msgLabel.set_text("")
		
		if togglebutton.get_active():
			for item in self.nat_list:
				item.set_sensitive(True)
				
			for item in self.nat_disabled_list:
					item.set_sensitive(True)
					
			
			if self.enableNatEnabled.get_active():
				for item in self.nat_disabled_list:
					item.set_sensitive(True)
			else:
				for item in self.nat_disabled_list:
					item.set_sensitive(False)				
					
				
		else:
			for item in self.nat_list:
				item.set_sensitive(False)
			for item in self.nat_disabled_list:
				item.set_sensitive(False)



		self.routing_gui_status=togglebutton.get_active()

	#def routingNATRadioToggled
	
	
	def checkStatus(self):
		
		self.routing=False
		self.NAT=False
		
		self.persistence=False
		
		if(subprocess.call(["llxcfg-net","routing","test"],stderr=subprocess.PIPE)==0):
			self.routing=True
			
		if(subprocess.call(["llxcfg-net","nat","test"],stderr=subprocess.PIPE)==0):
			self.NAT=True
			
		if(subprocess.call(["llxcfg-net","persistence","test"],stderr=subprocess.PIPE)==0):
			self.persistence=True
			
			
			

		
		self.nat_gui_status=self.NAT
		self.routing_gui_status=self.routing
					
		print "[*] Routing is %s"%("disabled","enabled")[self.routing]
		print "[*] NAT is %s"%("disabled","enabled")[self.NAT]
		print "[*] Persistence is %s"%("disabled","enabled")[self.persistence]		
		

		if not self.routing_gui_status:
			self.routingDisabledRadio.set_active(True)
			
		if not self.nat_gui_status:
			self.enableNatDisabled.set_active(True)
			
		self.checkPersistent.set_active(self.persistence)
		
		
	#def checkStatus
	

	
	def checkForEth(self):


		output=subprocess.Popen(["llxcfg-showvars",self.ext_var,self.int_var],stdout=subprocess.PIPE).communicate()[0]
		
		tmp_list=[]
		output=output.rstrip('\n')
		tmp_list=output.split('\n')

		
		self.ext_device=""
		self.int_device=""
		
		if len(tmp_list)==2:
		
			tmp_list2=[]
			tmp_list2=tmp_list[0].split("=")
			
			tmp_list2[1]=tmp_list2[1].strip(";")
			
			tmp_list2[1]=tmp_list2[1].strip("'")
			
			self.ext_device=tmp_list2[1]
			
			tmp_list2=[]
			tmp_list2=tmp_list[1].split("=")
			
			tmp_list2[1]=tmp_list2[1].strip(";")
			
			tmp_list2[1]=tmp_list2[1].strip("'")		
			
			self.int_device=tmp_list2[1]


		print self.ext_device,self.int_device,"!"
		
		output=subprocess.Popen(["lliurex-net","get_network_cards"],stdout=subprocess.PIPE).communicate()[0]
		
		self.eth_list=[]
		

		output=output.strip('\n')

		self.eth_list=output.split(" ")
		
		ext_locator=0
		int_locator=0
		
		ext_found=False
		int_found=False
		
		for eth in self.eth_list:
			#print eth
			if (len(eth)>0):
				self.internalCombobox.append_text(eth)
				if eth==self.int_device:
					self.internalCombobox.set_active(int_locator)
					int_found=True
				self.externalCombobox.append_text(eth)
				if eth==self.ext_device:
					self.externalCombobox.set_active(ext_locator)
					ext_found=True
				ext_locator+=1
				int_locator+=1
				
				
		if not ext_found:
			self.externalCombobox.set_active(0)
			
		if not int_found:
			self.internalCombobox.set_active(0)
				
		
		#llxcfg-showvars SRV_NIC SRV_MAC




				
			
				
		
		
		
	#def checkForEth
	
	
	def setLliurexVars(self):
		
		subprocess.call(["llxcfg-setvars",self.ext_var+"="+self.externalCombobox.get_active_text()]);
		subprocess.call(["llxcfg-setvars",self.int_var+"="+self.internalCombobox.get_active_text()]);
		
		
	#def setVars
	
	
	
	def enableNatEnabledToggled(self,togglebutton):
		
		self.msgLabel.set_text("")
		
		if togglebutton.get_active():
			#print "[*] NAT Enabled"
			for item in self.nat_disabled_list:
				item.set_sensitive(True)
		else:
			#print "[*] NAT Disabled"
			for item in self.nat_disabled_list:
				item.set_sensitive(False)
		
	#def enableNatEnabledToggled
	
	def applyButtonPress(self,button):
		
		print "[*] Begin modifications..."
		
		self.msgLabel.set_text("")
		
		if self.routingEnabledRadio.get_active():
			
			print "\t[*] Enabling routing..."
			subprocess.call(["llxcfg-net","routing","enable"])
			self.routing=True
			self.msgLabel.set_text(_("Routing enabled"))
			
			if self.enableNatEnabled.get_active():
				
				if (self.externalCombobox.get_active_text()!=self.internalCombobox.get_active_text()):
					print "\t[*] Enabling NAT..."
						
					self.setLliurexVars()
					
					subprocess.call(["llxcfg-net","nat","enable"])
						
					self.NAT=True

					if self.checkPersistent.get_active():
						print "\t[*] Enabling persistence..."
						subprocess.call(["llxcfg-net","persistence","enable"])
						self.persistence=True
						self.msgLabel.set_text(_("Persistent NAT Enabled"))
					else:
						print "\t[*] Disabling persistence..."
						subprocess.call(["llxcfg-net","persistence","disable"])
						self.persistence=False
						self.msgLabel.set_text(_("Non-persistent NAT Enabled"))				
					
				else:
					self.msgLabel.set_markup("<span foreground='red'>Eth Devices must be different</span>")
		
			else:
				
				if self.persistence:
					print "\t[*] Disabling persistence..."
					subprocess.call(["llxcfg-net","persistence","disable"])
					self.persistence=False
					
				if self.NAT:
					print "\t[*] Disabling NAT..."
					subprocess.call(["llxcfg-net","nat","disable"])
					self.NAT=False
					self.msgLabel.set_text(_("NAT Disabled"))


				
		else:
			
			if self.routing:
				
				if self.persistence:
					print "\t[*] Disabling persistence first..."
					subprocess.call(["llxcfg-net","persistence","disable"])
					self.persistence=False
					
				if self.NAT:
					print "\t[*] Disabling NAT first..." 
					subprocess.call(["llxcfg-net","nat","disable"])
					self.NAT=False
				
				
				print "\t[*] Disabling Routing..."
				subprocess.call(["llxcfg-net","routing","disable"])
				self.routing=False
				self.msgLabel.set_text(_("Routing Disabled"))
				
			else:
				print "\t[*] Routing already disabled"
	
		
		
	#def applyButtonPress
	
	
	
#class NatManager

if __name__=="__main__":
	
	nm=NatManager()
